# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .credit_note_response import CreditNoteResponse


class CreditNotePaginationResponse(UniversalBaseModel):
    """
    A paginated list of credit notes.
    """

    data: typing.List[CreditNoteResponse] = pydantic.Field()
    """
    List of credit notes for the current page
    """

    next_pagination_token: typing.Optional[str] = pydantic.Field(default=None)
    """
    Token to retrieve the next page of results
    """

    prev_pagination_token: typing.Optional[str] = pydantic.Field(default=None)
    """
    Token to retrieve the previous page of results
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
